// GetFreeSpaceDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GetFreeSpace.h"
#include "GetFreeSpaceDlg.h"
#include "Winbase.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CGetFreeSpaceDlg dialog

CGetFreeSpaceDlg::CGetFreeSpaceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetFreeSpaceDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGetFreeSpaceDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CGetFreeSpaceDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CGetFreeSpaceDlg::OnBnClickedButton1)
END_MESSAGE_MAP()


// CGetFreeSpaceDlg message handlers

BOOL CGetFreeSpaceDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CGetFreeSpaceDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_GETFREESPACE_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_GETFREESPACE_DIALOG));
	}
}
#endif


void CGetFreeSpaceDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	ULARGE_INTEGER TotalDisk;
	ULARGE_INTEGER UseDisk;
	ULARGE_INTEGER FreeDisk;
	GetDiskFreeSpaceEx(L"System_Disk",&UseDisk,&TotalDisk,&FreeDisk);
	printf("Free space %I64d byte\r\n",FreeDisk);

}
