﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.IO.Ports;
using System.Net;
using System.Net.Sockets;

namespace NetworkTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        NetworkStream NetStream;
        TcpClient NetClient;

        private void btnStart_Click(object sender, EventArgs e)
        {
            NetClient = new TcpClient();
            IPAddress IP;
            int length = int.Parse(txtLength.Text);
            int ServerPort = int.Parse(txtPort.Text);
            int dataSize = 0, error = 0; ;
            byte[] data = new byte[32768];
            byte[] defaultdata = new byte[32768];
            byte[] msg = new byte[32768];
            String ServerMsg = "";
            
            IP = System.Net.IPAddress.Parse(txtIP.Text);

            for (int i = 0; i < length; i++)
            {
                defaultdata[i] = (byte)(i % 255);
            }


            //build tcp connect
            try
            {
                NetClient.Connect(IP, ServerPort);
                txtMessage.Text = "Connect server ok";
            }
            catch (Exception ex)
            {
                txtMessage.Text = "Connect server error";
                return;
            }

            //send data
            try
            {
                txtMessage.Text = "send data to server...";
                String temp = "OPENNET_" + length.ToString();
                msg = Encoding.ASCII.GetBytes(temp);
                NetStream = NetClient.GetStream();
                NetStream.Write(msg, 0, msg.Length);
                txtMessage.Text = "send data ok";
            }
            catch (Exception ex)
            {
                txtMessage.Text = "send data error";
                return;
            }

            while (true)
            {
                txtMessage.Text = "get data from server...";
                dataSize = NetClient.ReceiveBufferSize;
                while (dataSize == 0)
                {
                    Application.DoEvents();
                    dataSize = NetClient.ReceiveBufferSize;
                }
                if (dataSize > int.Parse(txtLength.Text))
                    dataSize = int.Parse(txtLength.Text);
                //Console.WriteLine("dataSize " + dataSize.ToString());
                msg = new byte[32768];
                NetStream.Read(msg, 0, dataSize);
                ServerMsg = Encoding.ASCII.GetString(msg, 0, dataSize);
                if (ServerMsg.IndexOf("TESTEND") >= 0)
                {
                    break;
                }

               
                Application.DoEvents();

                txtMessage.Text = "compare data...";
                for (int i = 0; i < dataSize; i++)
                {
                    if (msg[i] != defaultdata[i])
                    {
                        error++;
                    }
                }
                txtError.Text = error.ToString();
                Application.DoEvents();

                msg = Encoding.ASCII.GetBytes("CHECKOK");
                //NetStream = NetClient.GetStream();
                NetStream.Write(msg, 0, msg.Length);
                //txtMessage.Text = "send data ok";
                Application.DoEvents();

                //recive data
                txtMessage.Text = "recive data from server...";
                Application.DoEvents();
                while (dataSize == 0)
                {
                    Application.DoEvents();
                    dataSize = NetClient.ReceiveBufferSize;
                }
                msg = new byte[32768];
                NetStream.Read(msg, 0, dataSize);
                for (int i = 0; i < dataSize; i++)
                {
                    if (msg[i] != defaultdata[i])
                    {
                        error++;
                    }
                }
                txtError.Text = error.ToString();
                Application.DoEvents();
            }
            txtMessage.Text = "Test finish";
        }
    }
}