﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;
using System.IO;
using System.Diagnostics;

namespace ProgramWDT
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }


        [System.Runtime.InteropServices.StructLayoutAttribute(System.Runtime.InteropServices.LayoutKind.Sequential, CharSet = System.Runtime.InteropServices.CharSet.Auto)]
        public struct PROCESSENTRY32
        {

            /// DWORD->unsigned int
            public uint dwSize;

            /// DWORD->unsigned int
            public uint cntUsage;

            /// DWORD->unsigned int
            public uint th32ProcessID;

            /// DWORD->unsigned int
            public uint th32DefaultHeapID;

            /// DWORD->unsigned int
            public uint th32ModuleID;

            /// DWORD->unsigned int
            public uint cntThreads;

            /// DWORD->unsigned int
            public uint th32ParentProcessID;

            /// LONG->int
            public int pcPriClassBase;

            /// DWORD->unsigned int
            public uint dwFlags;

            /// TCHAR[260]
            [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst = 260)]
            public string szExeFile;

            /// DWORD->unsigned int
            public uint th32MemoryBase;

            /// DWORD->unsigned int
            public uint th32AccessKey;
        }


        [System.Runtime.InteropServices.StructLayoutAttribute(System.Runtime.InteropServices.LayoutKind.Sequential)]
        public struct SECURITY_ATTRIBUTES
        {

            /// DWORD->unsigned int
            public uint nLength;

            /// LPVOID->void*
            public System.IntPtr lpSecurityDescriptor;

            /// BOOL->int
            [System.Runtime.InteropServices.MarshalAsAttribute(System.Runtime.InteropServices.UnmanagedType.Bool)]
            public bool bInheritHandle;
        }


        [DllImport("Toolhelp.dll")]
        public static extern IntPtr CreateToolhelp32Snapshot(uint flags, uint processid);

        [DllImport("Toolhelp.dll")]
        public static extern bool Process32First(IntPtr hSnapshot, ref PROCESSENTRY32 lppe);

        [DllImport("Toolhelp.dll")]
        public static extern bool Process32Next(IntPtr hSnapshot, ref PROCESSENTRY32 lppe);

        [DllImport("Toolhelp.dll")]
        public static extern bool CloseToolhelp32Snapshot(IntPtr hSnapshot);

        [DllImport("Coredll.dll")]
        public static extern IntPtr CreateMutex(SECURITY_ATTRIBUTES lpsa, bool bInitialOwner, string lpName);

        [DllImport("Coredll.dll")]
        public static extern int GetLastError();

        [DllImport("Coredll.dll")]
        public static extern bool CloseHandle(IntPtr Handle);

        string FileName = "";
        string FilePath = "";
        bool flag = false;
        ThreadStart myRun;
        Thread myThread;
        int looptime = 1000;


        public void ThreadFun()
        {

            bool lRes = false;
            PROCESSENTRY32 procEntry = new PROCESSENTRY32();
            procEntry.dwSize = (uint)Marshal.SizeOf(procEntry);
            IntPtr lProcSnapshot = new IntPtr();
            bool IsRun = true;

            while (true)
            {

                lProcSnapshot = CreateToolhelp32Snapshot(2, 0);
                if (lProcSnapshot != (IntPtr)(-1))
                {
                    procEntry.dwSize = (uint)Marshal.SizeOf(procEntry);
                    lRes = Process32First(lProcSnapshot, ref procEntry);

                    while (lRes)
                    {
                        if (procEntry.szExeFile == FileName)
                        {
                            IsRun = true;
                        }
                        lRes = Process32Next(lProcSnapshot, ref procEntry);
                        System.Threading.Thread.Sleep(5);
                    }
                    if (!IsRun)
                    {
                        Process.Start(FilePath, "");
                    }
                    IsRun = false;
                    System.Threading.Thread.Sleep(looptime);
                }
                CloseToolhelp32Snapshot(lProcSnapshot);

                lProcSnapshot = (IntPtr)null;

            }
        }


        public String GetFileName(String Path)
        {
            String name = "";
            int index = Path.LastIndexOf("\\");

            name = Path.Substring(index + 1);


            return name;
        }

        private void btnSelectFile_Click(object sender, EventArgs e)
        {
            openFileDialog1.ShowDialog();
            if (File.Exists(openFileDialog1.FileName))
            {
                FileName = GetFileName(openFileDialog1.FileName);
                txtPath.Text = openFileDialog1.FileName;
                FilePath = txtPath.Text;
                flag = true;
            }
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            if (!flag)
            {
                MessageBox.Show("You must select a program!!");
                return;
            }
            looptime = int.Parse(txtWDT.Text);

            SECURITY_ATTRIBUTES sa = new SECURITY_ATTRIBUTES();
            IntPtr hMutex = CreateMutex(sa, false, "FiXiNdUsOfTiDlE");

            //Error code ERROR_ALREADY_EXISTS is 183.
            if (GetLastError() == 183)
            {
                CloseHandle(hMutex);
                return;
            }
            myRun = new ThreadStart(ThreadFun);
            myThread = new Thread(myRun);
            myThread.Start();
        }

        private void Form1_Closed(object sender, EventArgs e)
        {
            myThread.Abort();
        }
    }
}