﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;


namespace SetDisplayPowerStatus
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        string szFullName = null;
        public int POWER_NAME = 1;
        public int ERROR_SUCCESS = 0;
        private void Form1_Load(object sender, EventArgs e)
        {
            szFullName = "{EB91C7C9-8BF6-4a2d-9AB8-69724EED97D1}\\\\Windows\\ddi.dll";
        }
        public class PowerAPI
        {
            [DllImport("coredll.dll", SetLastError = true)]
            public static extern int SetDevicePower(string pvDevice, int dwDeviceFlags, DevicePowerState DeviceState);

            [DllImport("coredll.dll", SetLastError = true)]
            public static extern int GetDevicePower(string pvDevice, int dwDeviceFlags, ref DevicePowerState DeviceState);

            [DllImport("coredll.dll", SetLastError = true)]
            public static extern int DevicePowerNotify(string device, DevicePowerState state, int flags);
           
            public enum DevicePowerState : int
            {

                Unspecified = -1,

                D0 = 0, // Full On: full power, full functionality  

                D1, // Low Power On: fully functional at low  power/performance  

                D2, // Standby: partially powered with automatic wake  

                D3, // Sleep: partially powered with device initiated wake  

                D4, // Off: unpowered  

            }
        }
        private void button1_Click(object sender, EventArgs e)
        {
            szFullName = "{EB91C7C9-8BF6-4a2d-9AB8-69724EED97D1}\\\\Windows\\ddi.dll";
        }

        private void button2_Click(object sender, EventArgs e)
        {
            szFullName = "{EB91C7C9-8BF6-4a2d-9AB8-69724EED97D1}\\\\Windows\\ddi_mq200.dll";
        }
        bool IdleState = false;
        private void button3_Click(object sender, EventArgs e)
        {
            szFullName = "BKL1:";
            IdleState = true;
        }
        void GetPowerstate()
        {
            PowerAPI.DevicePowerState cepower=new PowerAPI.DevicePowerState();
            if (PowerAPI.GetDevicePower(szFullName, POWER_NAME, ref cepower) == ERROR_SUCCESS)
	        {
                if (cepower == PowerAPI.DevicePowerState.D0)
			        Console.WriteLine("Power state for is D0");
                else if (cepower == PowerAPI.DevicePowerState.D1)
			        Console.WriteLine("Power state for is D1");
                else if (cepower == PowerAPI.DevicePowerState.D2)
			        Console.WriteLine("Power state for is D2");
                else if (cepower == PowerAPI.DevicePowerState.D3)
			        Console.WriteLine("Power state for is D3");
                else if (cepower == PowerAPI.DevicePowerState.D4)
			        Console.WriteLine("Power state for is D4");
		        else
			        Console.WriteLine("Power state for "+szFullName+" isn't defined");
	        }
	        else
                Console.WriteLine("GetDevicePower(" + szFullName + ") was unsuccessful");
        }

        private void button4_Click(object sender, EventArgs e)
        {
            GetPowerstate();
            Thread.Sleep(1000);
            Console.WriteLine("/////////////D4///////////");
            PowerAPI.SetDevicePower(szFullName, POWER_NAME, PowerAPI.DevicePowerState.D4);//Set suspend state
            Thread.Sleep(1000);
            GetPowerstate();
            Console.WriteLine("/////////////D0///////////");
            PowerAPI.SetDevicePower(szFullName, POWER_NAME, PowerAPI.DevicePowerState.D0);
            GetPowerstate();
            Console.WriteLine("//////////////////////////");

            if (IdleState)
            {
                Thread.Sleep(1000);
                Console.WriteLine("/////////////D3///////////");
                PowerAPI.SetDevicePower(szFullName, POWER_NAME, PowerAPI.DevicePowerState.D3);//Set idle state
                Thread.Sleep(1000);
                GetPowerstate();
                Console.WriteLine("/////////////D0///////////");
                PowerAPI.SetDevicePower(szFullName, POWER_NAME, PowerAPI.DevicePowerState.D0);
                GetPowerstate();
                Console.WriteLine("//////////////////////////");
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            GetPowerstate();
        }
    }
}