// buzzerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "buzzer.h"
#include "buzzerDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CbuzzerDlg dialog

CbuzzerDlg::CbuzzerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CbuzzerDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CbuzzerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CbuzzerDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CbuzzerDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CbuzzerDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CbuzzerDlg::OnBnClickedButton3)
END_MESSAGE_MAP()


// CbuzzerDlg message handlers

BOOL CbuzzerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CbuzzerDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_BUZZER_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_BUZZER_DIALOG));
	}
}
#endif


void CbuzzerDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	pac_SetBuzzerFreqDuty(200, 50);
	pac_BuzzerBeep(1, 100);
	Sleep(300);
	pac_SetBuzzerFreqDuty(400, 50);
	pac_BuzzerBeep(1, 100);
	Sleep(300);
	pac_SetBuzzerFreqDuty(600, 50);
	pac_BuzzerBeep(1, 100);
	Sleep(300);
	pac_SetBuzzerFreqDuty(800, 50);
	pac_BuzzerBeep(1, 100);
	Sleep(300);
	pac_SetBuzzerFreqDuty(1000, 50);
	pac_BuzzerBeep(1, 100);
	Sleep(300);
	pac_SetBuzzerFreqDuty(1200, 50);
	pac_BuzzerBeep(1, 100);
	Sleep(300);
	pac_SetBuzzerFreqDuty(1400, 50);
	pac_BuzzerBeep(1, 100);
	Sleep(300);
	pac_SetBuzzerFreqDuty(1600, 50);
	pac_BuzzerBeep(1, 100);
	Sleep(300);
}

void CbuzzerDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	pac_SetBuzzerFreqDuty(200, 50);
    pac_BuzzerBeep(1, 3000);// 1= run 3S ,0=run untill stopbuzzer esecute
	//Sleep(3200);
}

void CbuzzerDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here
	pac_StopBuzzer();
}
